#ifndef __HS_OPS_H
#define __HS_OPS_H

#include <stdint.h>

#ifdef __HS_DEBUG

#include "rcops_debug.h"

#else

#define __HS_RCLOG 3
extern int8_t __hs_rcs[];

#define RC_ADJUST(p, by) \
  ((p) ? __hs_rcs[(uintptr_t)(p) >> __HS_RCLOG] += (by) : 0)

#define __builtin_hs_trace()
#define __builtin_hs_adjust(adj, x, by, s) \
  ((adj)((x), (by), (s)))

#endif /* __HS_DEBUG */

#define RC_ADJUST_START(x, s)			\
  typeof(s) __rcs = (s);			\
  char *__rcend = (char *)(x) + (s);		\
  __rcnext:

#define RC_ADJUST_END(x, s)			\
  if (__rcs && (s))					\
    {						\
      (x) = (void *)((char *)(x) + (s));	\
      if ((char *)(x) + (s) <= __rcend)		\
	goto __rcnext;				\
    }

extern void **__hs_indirect_vars, **__hs_direct_vars;

#ifndef __HEAPSAFE__
/* Strangely enough, this means the time we're included after the cil pass */

static inline void __builtin_hs_push(const void *x)
{
  *__hs_direct_vars++ = (void *)x;
}

static inline void __builtin_hs_pop(const void *x)
{
  --__hs_direct_vars;
}

static inline void __builtin_hs_ipush(const void *x,
				      void (*t)(void *x, int by, __SIZE_TYPE__ s),
				      __SIZE_TYPE__ s)
{
  *__hs_indirect_vars++ = (void *)x;
  *__hs_indirect_vars++ = (void *)s;
  *__hs_indirect_vars++ = (void *)t;
}

static inline void __builtin_hs_ipop(const void *x,
				     void (*t)(void *x, int by, __SIZE_TYPE__ s),
				     __SIZE_TYPE__ s)
{
  __hs_indirect_vars -= 3;
}

#endif /* !__HEAPSAFE__ */

#endif /* __HS_OPS_H */
